
_MCU_Init:

;BrushlessAVR.c,81 :: 		void MCU_Init()
;BrushlessAVR.c,83 :: 		ADC_Init(); // ADC Init
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	CALL       _ADC_Init+0
;BrushlessAVR.c,84 :: 		pwm_period = 256;
	LDI        R27, 0
	STS        _pwm_period+0, R27
	LDI        R27, 1
	STS        _pwm_period+1, R27
;BrushlessAVR.c,85 :: 		PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT, _PWM16_PRESCALER_16bit_8, _PWM16_NON_INVERTED, 255, 1);  // PWM Init
	LDI        R27, 1
	MOV        R7, R27
	LDI        R27, 0
	MOV        R8, R27
	LDI        R27, 255
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	LDI        R27, 160
	MOV        R4, R27
	LDI        R27, 2
	MOV        R3, R27
	LDI        R27, 11
	MOV        R2, R27
	CALL       _PWM16bit_Init+0
;BrushlessAVR.c,86 :: 		PWM16bit_Start(_TIMER1);
	LDI        R27, 1
	MOV        R2, R27
	LDI        R27, 0
	MOV        R3, R27
	CALL       _PWM16bit_Start+0
;BrushlessAVR.c,87 :: 		PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);
	LDI        R27, 18
	MOV        R4, R27
	LDS        R2, _current_speed+0
	LDS        R3, _current_speed+1
	CALL       _PWM16bit_Change_Duty+0
;BrushlessAVR.c,89 :: 		Delay_ms(100);
	LDI        R18, 5
	LDI        R17, 15
	LDI        R16, 242
L_MCU_Init0:
	DEC        R16
	BRNE       L_MCU_Init0
	DEC        R17
	BRNE       L_MCU_Init0
	DEC        R18
	BRNE       L_MCU_Init0
;BrushlessAVR.c,91 :: 		current_speed = 0; //initial value for current duty
	LDI        R27, 0
	STS        _current_speed+0, R27
	STS        _current_speed+1, R27
;BrushlessAVR.c,92 :: 		}
L_end_MCU_Init:
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _MCU_Init

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;BrushlessAVR.c,94 :: 		void main() {
;BrushlessAVR.c,95 :: 		MCU_Init();
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _MCU_Init+0
;BrushlessAVR.c,96 :: 		Lcd_Init();                        // Initialize LCD
	CALL       _Lcd_Init+0
;BrushlessAVR.c,97 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;BrushlessAVR.c,98 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;BrushlessAVR.c,99 :: 		Lcd_Out(1, 1, txt1);
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;BrushlessAVR.c,100 :: 		Lcd_Out(2, 1, txt2);
	LDI        R27, #lo_addr(_txt2+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt2+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;BrushlessAVR.c,101 :: 		WordToStr(pwm_period, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDS        R2, _pwm_period+0
	LDS        R3, _pwm_period+1
	CALL       _WordToStr+0
;BrushlessAVR.c,102 :: 		Lcd_Out(2, 10, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;BrushlessAVR.c,104 :: 		DDB0_bit = 0;                      // Set PORTB pin 0 as input
	IN         R27, DDB0_bit+0
	CBR        R27, BitMask(DDB0_bit+0)
	OUT        DDB0_bit+0, R27
;BrushlessAVR.c,105 :: 		DDB1_bit = 0;                      // Set PORTB pin 1 as input
	IN         R27, DDB1_bit+0
	CBR        R27, BitMask(DDB1_bit+0)
	OUT        DDB1_bit+0, R27
;BrushlessAVR.c,106 :: 		DDA6_bit = 1;                      // Set PORTA pin 6 as output.
	IN         R27, DDA6_bit+0
	SBR        R27, BitMask(DDA6_bit+0)
	OUT        DDA6_bit+0, R27
;BrushlessAVR.c,107 :: 		DDD4_bit = 1;                      // Set PORTD pin 4 as output pin for the PWM (according to datasheet) OC1B, Output Compare Match B output: The PD4 pin can serve as an external output for theTimer/Counter1 Output Compare B
	IN         R27, DDD4_bit+0
	SBR        R27, BitMask(DDD4_bit+0)
	OUT        DDD4_bit+0, R27
;BrushlessAVR.c,108 :: 		MOTOR_DIR = CCW;
	IN         R27, PORTA6_bit+0
	CBR        R27, BitMask(PORTA6_bit+0)
	OUT        PORTA6_bit+0, R27
;BrushlessAVR.c,110 :: 		while(1) {
L_main2:
;BrushlessAVR.c,112 :: 		if (PINB0_bit)                  // button on PB0 pressed
	IN         R27, PINB0_bit+0
	SBRS       R27, BitPos(PINB0_bit+0)
	JMP        L_main4
;BrushlessAVR.c,114 :: 		Delay_ms(1);
	LDI        R17, 11
	LDI        R16, 99
L_main5:
	DEC        R16
	BRNE       L_main5
	DEC        R17
	BRNE       L_main5
;BrushlessAVR.c,115 :: 		current_speed = current_speed + STEP;   // increment current_duty
	LDS        R16, _current_speed+0
	LDS        R17, _current_speed+1
	MOVW       R18, R16
	SUBI       R18, 255
	SBCI       R19, 255
	STS        _current_speed+0, R18
	STS        _current_speed+1, R19
;BrushlessAVR.c,116 :: 		if (current_speed > pwm_period)       // if we increase current duty greater then possible pwm_period value
	LDS        R16, _pwm_period+0
	LDS        R17, _pwm_period+1
	CP         R16, R18
	CPC        R17, R19
	BRLO       L__main16
	JMP        L_main7
L__main16:
;BrushlessAVR.c,118 :: 		current_speed = 0;                // reset current duty value to zero
	LDI        R27, 0
	STS        _current_speed+0, R27
	STS        _current_speed+1, R27
;BrushlessAVR.c,119 :: 		}
L_main7:
;BrushlessAVR.c,120 :: 		PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);
	LDI        R27, 18
	MOV        R4, R27
	LDS        R2, _current_speed+0
	LDS        R3, _current_speed+1
	CALL       _PWM16bit_Change_Duty+0
;BrushlessAVR.c,122 :: 		}
L_main4:
;BrushlessAVR.c,124 :: 		if (PINB1_bit)                  // button on PB1 pressed
	IN         R27, PINB1_bit+0
	SBRS       R27, BitPos(PINB1_bit+0)
	JMP        L_main8
;BrushlessAVR.c,126 :: 		Delay_ms(1);
	LDI        R17, 11
	LDI        R16, 99
L_main9:
	DEC        R16
	BRNE       L_main9
	DEC        R17
	BRNE       L_main9
;BrushlessAVR.c,127 :: 		current_speed = current_speed - STEP;    // decrement current_duty
	LDS        R18, _current_speed+0
	LDS        R19, _current_speed+1
	SUBI       R18, 1
	SBCI       R19, 0
	STS        _current_speed+0, R18
	STS        _current_speed+1, R19
;BrushlessAVR.c,128 :: 		if (current_speed > pwm_period)       // if we decrease current duty below zero value
	LDS        R16, _pwm_period+0
	LDS        R17, _pwm_period+1
	CP         R16, R18
	CPC        R17, R19
	BRLO       L__main17
	JMP        L_main11
L__main17:
;BrushlessAVR.c,130 :: 		current_speed = pwm_period;         // set current duty value to pwm_period
	LDS        R16, _pwm_period+0
	LDS        R17, _pwm_period+1
	STS        _current_speed+0, R16
	STS        _current_speed+1, R17
;BrushlessAVR.c,131 :: 		}
L_main11:
;BrushlessAVR.c,132 :: 		PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);
	LDI        R27, 18
	MOV        R4, R27
	LDS        R2, _current_speed+0
	LDS        R3, _current_speed+1
	CALL       _PWM16bit_Change_Duty+0
;BrushlessAVR.c,133 :: 		}
L_main8:
;BrushlessAVR.c,135 :: 		Delay_ms(20);
	LDI        R17, 208
	LDI        R16, 202
L_main12:
	DEC        R16
	BRNE       L_main12
	DEC        R17
	BRNE       L_main12
	NOP
;BrushlessAVR.c,137 :: 		WordToStr(current_speed, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDS        R2, _current_speed+0
	LDS        R3, _current_speed+1
	CALL       _WordToStr+0
;BrushlessAVR.c,138 :: 		Lcd_Out(1, 10, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 10
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;BrushlessAVR.c,140 :: 		}
	JMP        L_main2
;BrushlessAVR.c,142 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main
