#line 1 "C:/Users/stefan.popovic/Desktop/Brushless/example/Brushless AVR/BrushlessAVR.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for avr/include/built_in.h"
#line 57 "C:/Users/stefan.popovic/Desktop/Brushless/example/Brushless AVR/BrushlessAVR.c"
 sbit MOTOR_DIR at PORTA6_bit;


 sbit LCD_RS at PORTA2_bit;
 sbit LCD_EN at PORTD6_bit;
 sbit LCD_D4 at PORTC4_bit;
 sbit LCD_D5 at PORTC5_bit;
 sbit LCD_D6 at PORTC6_bit;
 sbit LCD_D7 at PORTC7_bit;

 sbit LCD_RS_Direction at DDA2_bit;
 sbit LCD_EN_Direction at DDD6_bit;
 sbit LCD_D4_Direction at DDC4_bit;
 sbit LCD_D5_Direction at DDC5_bit;
 sbit LCD_D6_Direction at DDC6_bit;
 sbit LCD_D7_Direction at DDC7_bit;


 unsigned int current_speed;
 unsigned int pwm_period;
 char txt[24];
 char txt1[] = "PWM Duty";
 char txt2[] = "PWM MAX";

 void MCU_Init()
 {
 ADC_Init();
 pwm_period = 256;
 PWM16bit_Init(_PWM16_PHASE_CORRECT_MODE_8BIT, _PWM16_PRESCALER_16bit_8, _PWM16_NON_INVERTED, 255, 1);
 PWM16bit_Start(_TIMER1);
 PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);

 Delay_ms(100);

 current_speed = 0;
 }

 void main() {
 MCU_Init();
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, txt1);
 Lcd_Out(2, 1, txt2);
 WordToStr(pwm_period, txt);
 Lcd_Out(2, 10, txt);

 DDB0_bit = 0;
 DDB1_bit = 0;
 DDA6_bit = 1;
 DDD4_bit = 1;
 MOTOR_DIR =  0x00 ;

 while(1) {

 if (PINB0_bit)
 {
 Delay_ms(1);
 current_speed = current_speed +  1 ;
 if (current_speed > pwm_period)
 {
 current_speed = 0;
 }
 PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);

 }

 if (PINB1_bit)
 {
 Delay_ms(1);
 current_speed = current_speed -  1 ;
 if (current_speed > pwm_period)
 {
 current_speed = pwm_period;
 }
 PWM16bit_Change_Duty(current_speed, _TIMER1_CH_B);
 }

 Delay_ms(20);

 WordToStr(current_speed, txt);
 Lcd_Out(1, 10, txt);

 }

 }
